// Generated by CoffeeScript 1.10.0
(function() {
  var KicadGenerator, fs, mkdirp;

  fs = require('fs');

  mkdirp = require('mkdirp');

  KicadGenerator = (function() {
    function KicadGenerator(library) {
      this.library = library;
    }

    KicadGenerator.prototype.generate = function(name) {
      var dir, e, fd, i, len, nameObj, now, ref, ref1, ref2, refObj, showPinNames, showPinNumbers, timestamp;
      dir = './kikad';
      mkdirp.sync(dir);
      mkdirp.sync(dir + '/' + name);
      now = new Date;
      timestamp = (now.getDate()) + "/" + (now.getMonth() + 1) + "/" + (now.getYear() + 1900) + " " + (now.getHours()) + ":" + (now.getMinutes()) + ":" + (now.getSeconds());
      fd = fs.openSync(dir + "/" + name + ".lib", 'w');
      fs.writeSync(fd, "EESchema-LIBRARY Version 2.3 Date: " + timestamp + "\n");
      fs.writeSync(fd, '#encoding utf-8\n');
      ref = this.library.elements;
      for (i = 0, len = ref.length; i < len; i++) {
        e = ref[i];
        refObj = this._textObj('refDes', e);
        nameObj = this._textObj('name', e);
        fs.writeSync(fd, "#\n# " + e.name + "\n#\n");
        showPinNumbers = ((ref1 = e.schematics) != null ? ref1.showPinNumbers : void 0) ? 'Y' : 'N';
        showPinNames = ((ref2 = e.schematics) != null ? ref2.showPinNames : void 0) ? 'Y' : 'N';
        fs.writeSync(fd, "DEF " + e.name + " " + e.refDes + " 0 0 " + showPinNumbers + " " + showPinNames + " 1 L N\n");
        fs.writeSync(fd, "F0 \"" + e.refDes + "\" " + refObj.x + " " + refObj.y + " " + refObj.size + " H V " + refObj.halign + " " + refObj.valign + "NN\n");
        fs.writeSync(fd, "F1 \"" + e.name + "\" " + nameObj.x + " " + nameObj.y + " " + nameObj.size + " H V " + nameObj.halign + " " + nameObj.valign + "NN\n");
        fs.writeSync(fd, "ENDDEF\n");
      }
      fs.closeSync(fd);
      return console.log("Generating KiCad library '" + name + ".lib': OK");
    };

    KicadGenerator.prototype._textObj = function(name, element) {
      var obj;
      obj = element.symbol.attribute(name) || {};
      if (obj.x == null) {
        obj.x = 0;
      }
      if (obj.y == null) {
        obj.y = 0;
      }
      obj.halign = (function() {
        switch (obj.halign) {
          case 'center':
            return 'C';
          case 'right':
            return 'R';
          default:
            return 'L';
        }
      })();
      obj.valign = (function() {
        switch (obj.valign) {
          case 'center':
            return 'C';
          case 'bottom':
            return 'B';
          default:
            return 'T';
        }
      })();
      obj.size = Math.round(this.library.symbol.textSize);
      return obj;
    };

    return KicadGenerator;

  })();

  module.exports = KicadGenerator;

}).call(this);
