// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol,
    slice = [].slice;

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(lib, def) {
      var cap, handler, i, j, l, len, len1, len2, p, pin, pinNum, ref, ref1, ref2, ref3, s;
      this.lib = lib;
      this.mergeObjects(this, def);
      this.refDes = 'REF';
      this.symbol = new QedaSymbol(this);
      this.patterns = [];
      this.pins = [];
      for (pin in this.pinout) {
        if (!Array.isArray(this.pinout[pin])) {
          this.pinout[pin] = [this.pinout[pin]];
        }
        ref = this.pinout[pin];
        for (i = 0, len = ref.length; i < len; i++) {
          pinNum = ref[i];
          this.pins[pinNum] = {
            name: pin
          };
        }
      }
      if (((ref1 = this.schematics) != null ? ref1.symbol : void 0) != null) {
        ref2 = this.lib.symbolDefs;
        for (j = 0, len1 = ref2.length; j < len1; j++) {
          s = ref2[j];
          cap = s.regexp.exec(this.schematics.symbol);
          if (cap) {
            handler = require("./symbol/" + this.lib.symbolStyle + "/" + s.handler);
            handler.apply(null, [this.symbol].concat(slice.call(cap.slice(1))));
          }
        }
      }
      if (!Array.isArray(this["package"])) {
        this["package"] = [this["package"]];
      }
      ref3 = this["package"];
      for (l = 0, len2 = ref3.length; l < len2; l++) {
        p = ref3[l];
        if (typeof p === 'object') {
          this.addPattern(p);
        } else if (typeof p === 'string') {
          if (this[p] != null) {
            this.addPattern(this[p]);
          }
        }
      }
      handler = require("./element/" + this.lib.elementStyle);
      handler(this);
    }

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype.addPattern = function(packageDef) {
      var cap, handler, i, len, p, pattern, ref;
      if (packageDef.pattern == null) {
        return;
      }
      pattern = new QedaPattern(this);
      ref = this.lib.patternDefs;
      for (i = 0, len = ref.length; i < len; i++) {
        p = ref[i];
        cap = p.regexp.exec(packageDef.pattern);
        if (cap) {
          handler = require("./pattern/" + this.lib.patternStyle + "/" + p.handler);
          handler.apply(null, [pattern].concat(slice.call(cap.slice(1))));
        }
      }
      return this.patterns.push(pattern);
    };

    QedaElement.prototype.pinDef = function(pinNum) {
      return this.pins[pinNum];
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
